import es
import spe
import cfglib
import vecmath
import playerlib
import gamethread


info = es.AddonInfo()
info.name = 'Flying Blade'
info.version = 1.1
info.basename = 'flying_blade'
info.url = 'http://addons.eventscripts.com/addons/view/flying_blade'
info.author = 'Dead Man Walker'


cfg = cfglib.AddonCFG(es.ServerVar('eventscripts_gamedir') + "/cfg/" + info.basename + ".cfg")
cfg.text("*****************************************************************")
cfg.text("*** %s Config" %info.name)
cfg.text("*****************************************************************")
cfg.text(' ')
KNIFE_AMOUNT = cfg.cvar('fb_knife_amount', 5, 'Amount of knifes to throw per round. Set to 0 for infinite')
KNIFE_AMOUNT_MSG = cfg.cvar('fb_knife_amount_msg', 1, 'Alert players of their remaining knifes to throw. 1=yes, 0=no')
KNIFE_DAMAGE = cfg.cvar('fb_knife_damage', 30, 'Amount of damge done by the thrown knife. Set to "kill" for instant death')
KNIFE_COLOR = cfg.cvar('fb_knife_color', "255,255,255,255", 'Color of the thrown knife in "rgba" format. Spereate with comma (,)')
KNIFE_ANGLE = cfg.cvar('fb_knife_angle', 60, 'Angle the thrown knife is turned. Set to "rotate" for rotating')
KNIFE_ROTATE_SPEED = cfg.cvar('fb_knife_rotate_speed', 10, 'Rotating speed if fb_knife_angle is set to "rotate"')
KNIFE_SPEED = cfg.cvar('fb_knife_speed', 15, 'Amount of speed of the thrown knife')
KNIFE_SIZE = cfg.cvar('fb_knife_size', 1.7, 'Scale of the thrown knife model (>0 and <7)')
KNIFE_SOUND = cfg.cvar('fb_knife_sound', "weapons/iceaxe/iceaxe_swing1.wav", 'Sound when knife is thrown. Set to 0 for no sound')
IGNORED_CLASSNAMES = cfg.cvar('fb_ignored_classnames', "trigger_soundscape;func_buyzone;func_breakable_surf;func_hostage_rescue", 'Classnames of entities the thrown knife ignores (does not get removed). Spereate with semicolons (;)')
MODEL_SIZE_LINUX_OFFSET = cfg.cvar('fb_model_size_linux_offset', 880, 'Linux offset of "m_flModelScale". May be changed on update')
TELEPORT_WINDOWS_OFFSET = cfg.cvar('fb_teleport_windows_offset', 108, 'Windows offset of "CBaseFlex::Teleport". May be changed on update')
TOUCH_WINDOWS_OFFSET = cfg.cvar('fb_touch_windows_offset', 99, 'Windows offset of "CBasePlayer::Touch". May be changed on update')
cfg.write()
cfg.execute()

indexes = []
players = {}
MODEL_SIZE_OFFSET = int(MODEL_SIZE_LINUX_OFFSET) + 20 if spe.platform == "nt" else int(MODEL_SIZE_LINUX_OFFSET)
SIZEOF_VECTOR = 12
model_index = es.precachemodel("models/weapons/w_knife_ct.mdl")

def load():
   es.addons.registerTickListener(tick)
   es.doblock('corelib/noisy_on')
   for userid in playerlib.getUseridList('#alive'):
      players[userid] = 0
   if str(KNIFE_SOUND):
      es.stringtable('downloadables', 'sound/' + str(KNIFE_SOUND).replace('sound/', ''))

def unload():
   spe.unHookFunction(FUNC_TOUCH, spe.HookType.Pre, preTouchEntity)
   es.addons.unregisterTickListener(tick)
   es.doblock('corelib/noisy_off')

def round_start(event_var):
   global indexes
   indexes = []

def es_map_start(event_var):
   global model_index
   players.clear()
   if str(KNIFE_SOUND):
      es.stringtable('downloadables', 'sound/' + str(KNIFE_SOUND).replace('sound/', ''))
   model_index = es.precachemodel("models/weapons/w_knife_ct.mdl")

def player_spawn(event_var):
   players[int(event_var['userid'])] = 0

def weapon_fire(event_var):
   weapon = event_var['weapon']
   userid = int(event_var['userid'])
   player = playerlib.getPlayer(userid)
   if weapon == 'knife' and (players[userid] < int(KNIFE_AMOUNT) or not int(KNIFE_AMOUNT)):
      index = es.createentity('flashbang_projectile')
      indexes.append(index)
      x, y, z = player.getEyeLocation()
      ax, ay, az = player.getViewAngle()
      targetname = '%s_flash' %index
      es.entitysetvalue(index, 'targetname', targetname)
      es.entitysetvalue(index, 'origin', "%s %s %s" %(x, y, z))
      try:
         knife_angle = int(KNIFE_ANGLE)
      except TypeError:
         knife_angle = 60
      es.entitysetvalue(index, 'angles', "%s %s %s" %(ax + int(knife_angle), ay, az))
      es.setindexprop(index, "CBaseEntity.m_CollisionGroup", 1)
      es.setindexprop(index, "CBaseEntity.m_hOwnerEntity", player.handle)
      es.InsertServerCommand('es_xfire %s %s addoutput "Touch !self,break"' % (userid, targetname))
      gamethread.delayed(0.06, es.setindexprop, (index, "CBaseEntity.m_CollisionGroup", 0))
      es.spawnentity(index)
      vec = vecmath.Vector(player.getViewCoord()) - vecmath.Vector(player.getEyeLocation())
      setVelocity(index, vec.setlength(100*int(KNIFE_SPEED)))
      players[userid] += 1
      if str(KNIFE_SOUND):
         es.playsound(userid, str(KNIFE_SOUND).replace('sound/', ''), 0.8)
      if players[userid] < int(KNIFE_AMOUNT) and int(KNIFE_AMOUNT_MSG):
         amount = int(KNIFE_AMOUNT)-players[userid]
         if amount == 1:
            es.tell(userid, '#multi', '#greenYou have #lightgreen%s #greenknife left to throw' %amount)
         else:
            es.tell(userid, '#multi', '#greenYou have #lightgreen%s #greenknifes left to throw' %amount)

def tick():
   if indexes:
      for index in indexes:
         es.setindexprop(index, "CWorld.baseclass.m_nModelIndex", model_index)
         entity_pointer = spe.getEntityOfIndex(index)
         if entity_pointer:
            model_size = spe.getLocVal('i', entity_pointer + int(MODEL_SIZE_OFFSET))
            color = str(KNIFE_COLOR).strip().split(',')
            es.entitysetvalue(index, 'rendercolor', "%s %s %s %s" %(color[0], color[1], color[2], color[3]))
            spe.setLocVal('i', entity_pointer + int(MODEL_SIZE_OFFSET), 1055353216 + float(KNIFE_SIZE)*10000000)
            if not str(KNIFE_ANGLE).isdigit():
               angle = es.entitygetvalue(index, 'angles').split(' ')
               es.entitysetvalue(index, 'angles', "%s %s %s" %(float(angle[0])+int(KNIFE_ROTATE_SPEED), angle[1], angle[2]))

def setVelocity(index, *a, **kw):
   entity_pointer = spe.getEntityOfIndex(index)
   if not entity_pointer:
      return
   coords = vecmath.Vector(*a, **kw).getdict()
   vector = spe.makeObject('Vector', spe.alloc(SIZEOF_VECTOR))
   for coord in coords:
      setattr(vector, coord, coords[coord])
   spe.setCallingConvention('thiscall')
   spe.callFunction(spe.findVirtualFunc(entity_pointer, int(TELEPORT_WINDOWS_OFFSET)),
    'pppp)v', (entity_pointer, 0, 0, vector.base))
   spe.dealloc(vector.base)

def preTouchEntity(args):
   ent_index = spe.getEntityIndex(args[1])
   touched_index = spe.getEntityIndex(args[0])
   touched_name = es.entitygetvalue(touched_index, 'classname')

   if ent_index in indexes and not touched_name in str(IGNORED_CLASSNAMES).strip().split(';'):
      player_indexes = {}
      for player in playerlib.getPlayerList('#alive'):
         player_indexes[player.index] = player.userid
      if touched_index in player_indexes:
         if str(KNIFE_DAMAGE).isdigit():
            dmg = int(KNIFE_DAMAGE)
         else:
            dmg = "#health"
         es.InsertServerCommand('damage %s %s %s %s %s' %(
          player_indexes[touched_index], 
          dmg,
          32,
          player_indexes[es.getindexfromhandle(es.getindexprop(ent_index, "CBaseEntity.m_hOwnerEntity"))],
          4
         ))
      spe.removeEntityByInstance(args[1])
      indexes.remove(ent_index)
   return (spe.HookAction.Continue, 0)

def hookTouch(callback):
   index = es.createentity('info_target')
   pointer = spe.getEntityOfIndex(index)
   func = spe.findVirtualFunc(pointer, int(TOUCH_WINDOWS_OFFSET))
   spe.hookFunction(func, 'pp)v', spe.Conventions.THISCALL, spe.HookType.Pre, callback)
   spe.removeEntityByInstance(pointer)
   return func

FUNC_TOUCH = hookTouch(preTouchEntity)